#include <boost/multi_index_container.hpp>
#include <boost/multi_index/mem_fun.hpp>
#include <boost/multi_index/hashed_index.hpp>

typedef int ObjectId;

struct Item
{
  ObjectId getId(){return 0;}
};

using namespace boost::multi_index;

typedef multi_index_container<
  Item*,
  indexed_by<            
    hashed_unique<mem_fun<Item, ObjectId, &Item::getId> >
  > 
> ItemsContainer;

int main()
{
  ItemsContainer c;
  c.insert(new Item);
}

